################################################################################
# Variance Decomposition
################################################################################


cnames=c("Belgium"  ,"Denmark"  ,"Finland" , "France" ,  "Germany" , "Ireland" , "Italy"  , "Netherlands", "Norway",   "Spain"   , "Sweden"   ,"Switzerland", "United Kingdom"   ,   "Australia", "Canada" , "Japan" ,  "United States"  )   

nr=13

logpr_dm_y =read.csv("ydata_logpr_rho15_2.csv" )  
x_fac =  read.csv("factor_logpr_rho15_2.csv" ) 
x_lam =  read.csv("lambda_logpr_rho15_2.csv" ) 
x_y=read.csv("ydata_logpr_rho15_2.csv" )   


logpr_dm_y =read.csv("ydata_logpr_rho15_2.csv" )%>%filter(year>=1999,year<=2007) 

x_fac =  read.csv("factor_logpr_rho15_2.csv" ) %>%filter(year>=1999,year<=2007) 
x_lam =  read.csv("lambda_logpr_rho15_2.csv" ) 
x_y=read.csv("ydata_logpr_rho15_2.csv" )%>%filter(year>=1999,year<=2007) 

fac_dm=sweep(x_fac,2,colMeans(x_fac),"-")
lam=x_lam
y_dm =sweep(x_y,2,colMeans(x_y),"-")

temp=fac_dm$f_1
temp1= lam$lambda
temp2= kronecker((temp),t(temp1) ) 
var_f1_dm=NULL
for( i in seq(1,ncol(temp2),1)){
  x=var(temp2[,i])
  var_f1_dm=rbind(var_f1_dm, x)
}

temp= fac_dm$r1_1
temp1=  lam$lambda1
temp2= kronecker((temp),t(temp1) )

temp_= fac_dm$r2_1
temp1_= lam$lambda2
temp2_= kronecker((temp_),t(temp1_) )

temp3= cbind( temp2[,1:nr],temp2_[,(nr+1):ncol(temp2_)] ) 

var_r_dm =NULL
for( i in seq(1,ncol(temp3),1)){
  x=var(temp3[,i])
  var_r_dm=rbind(var_r_dm, x)
}

temp=fac_dm$f_1
temp1=lam$lambda
temp2= kronecker((temp),t(temp1) ) 
temp4=y_dm[,3:ncol(y_dm)]-temp2-temp3

#dmean
temp4=sweep(temp4,2,colMeans(temp4),"-")

var_c_dm =NULL
for( i in seq(1,ncol(temp4),1)){
  x=var(temp4[,i])
  var_c_dm=rbind(var_c_dm, x)
}


per_logpr_rho15_dm_c =var_c_dm/(var_c_dm+var_f1_dm+var_r_dm)
per_logpr_rho15_dm_f1  =var_f1_dm/(var_c_dm+var_f1_dm+var_r_dm)
per_logpr_rho15_dm_r =var_r_dm/(var_c_dm+var_f1_dm+var_r_dm)
per_logpr_rho15_dm_c_9907 =var_c_dm/(var_c_dm+var_f1_dm+var_r_dm)
per_logpr_rho15_dm_f1_9907 =var_f1_dm/(var_c_dm+var_f1_dm+var_r_dm)
per_logpr_rho15_dm_r_9907=var_r_dm/(var_c_dm+var_f1_dm+var_r_dm)


logpr_dm_y =read.csv("ydata_logpr_rho15_2.csv" )%>%filter(year>=1999,year<=2007)

PVx_fac =  read.csv("factor_PVrp_rho15_logpr_2.csv" )%>%filter(year>=1999,year<=2007) 
PVx_lam =  read.csv("lambda_PVrp_rho15_logpr_2.csv" ) 
PVx_y=read.csv("ydata_PVrp_rho15_logpr_2.csv" ) %>%filter(year>=1999,year<=2007) 

var_logpr_dm =NULL
temp=logpr_dm_y%>%select(-year,-quarter)
for( i in seq(1,ncol(temp),1)){
  x=var(temp[,i])
  var_logpr_dm=rbind(var_logpr_dm, x)
}

fac_dm=sweep(PVx_fac,2,colMeans(PVx_fac),"-")
lam=PVx_lam
y_dm =sweep(PVx_y,2,colMeans(PVx_y),"-")

temp=fac_dm$f_1
temp1= lam$lambda
temp2= kronecker((temp),t(temp1) ) 
var_f1_dm=NULL
for( i in seq(1,ncol(temp2),1)){
  x=var(temp2[,i])
  var_f1_dm=rbind(var_f1_dm, x)
}

temp= fac_dm$r1_1
temp1=  lam$lambda1
temp2= kronecker((temp),t(temp1) )

temp_= fac_dm$r2_1
temp1_= lam$lambda2
temp2_= kronecker((temp_),t(temp1_) )

temp3= cbind( temp2[,1:nr],temp2_[,(nr+1):ncol(temp2_)] ) 

var_r_dm =NULL
for( i in seq(1,ncol(temp3),1)){
  x=var(temp3[,i])
  var_r_dm=rbind(var_r_dm, x)
}

temp=fac_dm$f_1
temp1=lam$lambda
temp2= kronecker((temp),t(temp1) ) 
temp4=y_dm[,3:ncol(y_dm)]-temp2-temp3

#dmean
temp4=sweep(temp4,2,colMeans(temp4),"-")

var_c_dm =NULL
for( i in seq(1,ncol(temp4),1)){
  x=var(temp4[,i])
  var_c_dm=rbind(var_c_dm, x)
}


per_PVrp_rho15_logpr_dm_f1_9907 =var_f1_dm/var_logpr_dm
per_PVlogri_rho15_logpr_dm_f1_9907 =var_f1_dm/var_logpr_dm
per_PVdlogrr_rho15_logpr_dm_f1_9907 =var_f1_dm/var_logpr_dm




